Stashbase

API overview

Overview of Stashbase API

Beta - This API is in beta and there may be changes in the future.

Stashbase public REST API allows you to programmatically interact with your projects, environments, secrets, and more. This API is used by our official SDKs and CLI and is separate from our rest API for web dashboard.

The base URL for the Stashbase REST API is:

https://api.stashbase.dev

Authentication

The Stashbase REST API uses API keys for authentication. You can generate an API key (personal, environment or service) in the Stashbase web dashboard.

To authorize your requests, you need to provide your API key in the Authorization header with the Bearer scheme.

curl -X GET "https://api.stashbase.dev/v1/projects" -H "Authorization: Bearer <API_KEY>"

Rate Limiting

To prevent abuse, API has rate limits based on the API key type and accessed resource type.

Access with personal API key is rate limited by the user, environment account access is rate limited by the environment and service account access is rate limited by the individual API key, not the service account.

Rate limits are shared per each resource type. Unauthorized requests are not counted towards the rate limits and have own rate limit of 30 requests per minute to prevent abuse.

The following are the rate limits for the REST API:

Resource TypeRate Limit (per minute)
General180 read / 120 write
Secrets100 read / 100 write
Scans30 requests

On this page